// afontestwn.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include <commdlg.h>
#include "afontestwn.h"
#include "choosefont.h"

// charsetIDEFAULT_CHARSETɒu
#define FORCE_CHARSET_DEFAULT

#define MAX_LOADSTRING 100

// O[oϐ:
HINSTANCE			g_hInst;			// ݂̃C^[tFCX
HWND				g_hWndMenuBar;		// j[ o[ nh

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
ATOM			MyRegisterClass(HINSTANCE, LPTSTR);
BOOL			InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

// O[oϐ:
HWND hwndMain = NULL;
TCHAR szTitle[MAX_LOADSTRING];				// ^Cg o[ eLXg
TCHAR szWindowClass[MAX_LOADSTRING];			// ^Cg o[ eLXg

LOGFONT currentLogFont;
TCHAR currentFaceName[32];
TEXTMETRIC currentTextMetric;
OUTLINETEXTMETRIC currentOutlineTextMetric;
TCHAR otmpFamilyName[_MAX_PATH];
TCHAR otmpFaceName[_MAX_PATH];
TCHAR otmpStyleName[_MAX_PATH];
TCHAR otmpFullName[_MAX_PATH];
int currentTextAlign = TA_TOP;
int currentBkMode = OPAQUE;
COLORREF currentBkColor = RGB(255,255,255);
COLORREF currentTextColor = RGB(0,0,0);
COLORREF currentEraseColor = RGB(128,0,0);
BOOL drawBaseLine = TRUE;
BOOL drawBoudingBox = FALSE;

// Windows Mobile 5,0ɂ݂͑Ȃ̂ŁAi
int GetScrollPos( HWND hWnd, int nBar )
{
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_POS;
	GetScrollInfo( hWnd, nBar, &si );
	return si.nPos;
}

// Windows Mobile 5,0ɂ݂͑Ȃ̂ŁAi
BOOL GetScrollRange( HWND hWnd, int nBar, LPINT lpMinPos, LPINT lpMaxPos )
{
	BOOL result;
	SCROLLINFO si;
	si.cbSize = sizeof(SCROLLINFO);
	si.fMask = SIF_RANGE;
	result = GetScrollInfo( hWnd, nBar, &si );
	*lpMinPos = si.nMin;
	*lpMaxPos = si.nMax;
	return result;
}

// Windows Mobile 5,0̃wb_[ɂ݂͑Ȃ̂ŁAڌĂяo
BOOL ChooseFont(LPCHOOSEFONT lpChooseFont )
{
	HINSTANCE hinst = LoadLibraryW(L"Commdlg.dll");
	LPCHOOSEFONTWPROC farproc = (LPCHOOSEFONTWPROC)GetProcAddressW(hinst,L"ChooseFontW");
	return farproc(lpChooseFont);
}

void setupTargetDC( HDC hdc )
{
	HFONT hfont = CreateFontIndirect( &currentLogFont );
	SelectObject( hdc, hfont );
	SetTextAlign( hdc, currentTextAlign );
	SetBkMode( hdc, currentBkMode );
	SetTextColor( hdc, currentTextColor );
	SetBkColor( hdc, currentBkColor );
}

void unsetupTargetDC( HDC hdc )
{
	HFONT hfont = (HFONT)SelectObject( hdc, GetStockObject(SYSTEM_FONT) );
	DeleteObject( hfont );
}

HDC getTargetDC()
{
	HDC hdc = GetDC( hwndMain );
	setupTargetDC( hdc );
	return hdc;
}

void releaseTargetDC(HDC hdc)
{
	unsetupTargetDC( hdc );
	ReleaseDC( hwndMain, hdc );
}

// display info
int horizontalDisplayCharacters = 16;
int verticalDisplayCharacters = 16;
int widthNumber = 0;
int widthOffset = 0;
int heightOffset = 0;

const int totalCharacters = 65535;

void sizeChanged()
{
	RECT rect;
	GetClientRect( hwndMain, &rect );

	TEXTMETRIC tmfixed;
	HDC hdc = GetDC( hwndMain );
	SelectObject( hdc, GetStockObject(SYSTEM_FONT));
	GetTextMetrics( hdc, &tmfixed );
	ReleaseDC( hwndMain, hdc );

	heightOffset = currentTextMetric.tmHeight+
		max(3,currentTextMetric.tmExternalLeading);
	widthOffset = currentTextMetric.tmMaxCharWidth+currentTextMetric.tmOverhang+3;

	widthNumber = tmfixed.tmAveCharWidth * 5;
	int bodyWidth = (rect.right-rect.left)-widthNumber;
	horizontalDisplayCharacters = bodyWidth/widthOffset;
	if( horizontalDisplayCharacters < 16 ) horizontalDisplayCharacters = 16;
	verticalDisplayCharacters = totalCharacters/horizontalDisplayCharacters;

	int hscrollRange = widthNumber+horizontalDisplayCharacters*widthOffset
							-(rect.right-rect.left);
	SetScrollRange( hwndMain, SB_HORZ, 0, max(0,hscrollRange), FALSE );
	int vscrollRange = verticalDisplayCharacters;
	SetScrollRange( hwndMain, SB_VERT, 0, max(0,vscrollRange), FALSE );
	InvalidateRect( hwndMain, NULL, TRUE );
}

void wmPaint( HWND hwnd, HDC hdc )
{
	RECT rect;
	GetClientRect( hwndMain, &rect );

	int startLine = GetScrollPos( hwnd, SB_VERT );
	int horzOffset = GetScrollPos( hwnd, SB_HORZ );
	int screenLines = (rect.bottom-rect.top)/heightOffset+1;
	int heightOriginOffset = 0;
	if( currentTextAlign == TA_BASELINE ) {
		heightOriginOffset = currentTextMetric.tmAscent;
	} else if( currentTextAlign == TA_BOTTOM ) {
		heightOriginOffset = currentTextMetric.tmHeight;
	}

	SelectObject( hdc, GetStockObject(SYSTEM_FONT) );
	SetBkMode( hdc, TRANSPARENT );
	SetTextColor( hdc, currentBkColor );
	for( int i=startLine; i<startLine+screenLines; i++ ) {
		int idx = i*horizontalDisplayCharacters;
		if( idx <= totalCharacters ) {
			int x = -horzOffset;
			int y = (i-startLine) * heightOffset + currentTextMetric.tmExternalLeading/2;
			TCHAR buf[6];
			wsprintf( buf, L"%04x:", (TCHAR)idx );
			ExtTextOut( hdc, x, y, 0, NULL, buf, lstrlen(buf), NULL );
		}
	}

	setupTargetDC( hdc );
	for( int i=startLine; i<startLine+screenLines; i++ ) {
		int baseline = heightOriginOffset + (i-startLine) * heightOffset + currentTextMetric.tmExternalLeading/2;
		for( int j=0; j<horizontalDisplayCharacters; j++ ) {
			int idx = i*horizontalDisplayCharacters+j;
			if( idx <= totalCharacters ) {
				int x = widthNumber + j * widthOffset + 1 - horzOffset;
				int y = baseline;
				TCHAR ch = (TCHAR)idx;
				ExtTextOut( hdc, x, y, 0, NULL, &ch, 1, NULL );
				if( drawBoudingBox ) {
					SIZE size;
					GetTextExtentPoint32( hdc, &ch, 1, &size );
					HPEN hpen = CreatePen(PS_DASH,1,RGB(255,255,255));
					HGDIOBJ oldPen = SelectObject( hdc, hpen );
					HGDIOBJ oldBrush = SelectObject( hdc, GetStockObject(NULL_BRUSH) );
					int oldROP = SetROP2( hdc, R2_NOT );
					Rectangle( hdc, x-1, y-1-heightOriginOffset, x+size.cx+1,y + size.cy+1-heightOriginOffset );
					SetROP2( hdc, oldROP );
					SelectObject( hdc, oldPen );
					SelectObject( hdc, oldBrush );
					DeleteObject( hpen );
				}
			}
		}
		if( drawBaseLine ) {
			HPEN hpen = CreatePen(PS_DASH,1,RGB(255,255,255));
			HGDIOBJ oldPen = SelectObject( hdc, hpen );
			int oldROP = SetROP2( hdc, R2_XORPEN );
			MoveToEx( hdc, rect.left, baseline, NULL );
			LineTo( hdc, rect.right, baseline );
			SetROP2( hdc, oldROP );
			SelectObject( hdc, oldPen );
			DeleteObject( hpen );
		}
	}
	unsetupTargetDC( hdc );
}

int GetDlgItemInt( HWND hDlg, int nIDDlgItem )
{
	TCHAR buf[_MAX_PATH];
	GetDlgItemText( hDlg, nIDDlgItem, buf, sizeof(buf) ); 
	int n = _wtoi(buf);
	return n;
}

int GetDlgItemHex6( HWND hDlg, int nIDDlgItem )
{
	TCHAR buf[_MAX_PATH];
	GetDlgItemText( hDlg, nIDDlgItem, buf, sizeof(buf) );
	TCHAR * endptr;
	int n = wcstol( buf, &endptr, 16 );
	return n;
}

void fillLogFont1( HWND hwndDlg, LOGFONT& lf )
{
	lf.lfHeight = GetDlgItemInt( hwndDlg, CFD_HEIGHT );
	lf.lfWidth = GetDlgItemInt( hwndDlg, CFD_WIDTH );
	lf.lfEscapement = GetDlgItemInt( hwndDlg, CFD_ESCAPEMENT );
	lf.lfOrientation = GetDlgItemInt( hwndDlg, CFD_ORIENTATION );
	lf.lfWeight = GetDlgItemInt( hwndDlg, CFD_WEIGHT );
	lf.lfItalic = GetDlgItemInt( hwndDlg, CFD_ITALIC );
	lf.lfUnderline = GetDlgItemInt( hwndDlg, CFD_UNDERLINE );
	lf.lfStrikeOut = GetDlgItemInt( hwndDlg, CFD_STRIKEOUT );
}

void fillLogFont2( HWND hwndDlg, LOGFONT& lf )
{
	lf.lfCharSet = GetDlgItemInt( hwndDlg, CFD_CHARSET );
	lf.lfOutPrecision = GetDlgItemInt( hwndDlg, CFD_OUTPUTPRECISION );
	lf.lfClipPrecision = GetDlgItemInt( hwndDlg, CFD_CLIPPRECISION );
	lf.lfQuality = GetDlgItemInt( hwndDlg, CFD_QUALITY );
	lf.lfPitchAndFamily = 
		(GetDlgItemInt( hwndDlg, CFD_PITCH ) & 0x03)
		| (GetDlgItemInt( hwndDlg, CFD_FAMILY ) & 0xf0);
	GetDlgItemText( hwndDlg, CFD_FACENAME, lf.lfFaceName, sizeof(lf.lfFaceName) );
}

void fillDrawInfo( HWND hwndDlg )
{
	currentTextAlign = GetDlgItemInt( hwndDlg, IDC_TEXTALIGN );
	currentBkMode = GetDlgItemInt( hwndDlg, IDC_BKMODE );
	currentBkColor = GetDlgItemHex6( hwndDlg, IDC_BKCOLOR );
	currentTextColor = GetDlgItemHex6( hwndDlg, IDC_TEXTCOLOR );
	currentEraseColor = GetDlgItemHex6( hwndDlg, IDC_ERASECOLOR );

	drawBaseLine = ( BST_CHECKED == SendDlgItemMessage( hwndDlg, IDC_BASELINE, BM_GETCHECK, 0, 0L ) );
	drawBoudingBox = ( BST_CHECKED == SendDlgItemMessage( hwndDlg, IDC_BOXDRAW, BM_GETCHECK, 0, 0L ) );
}

void initDrawParams()
{
	currentTextAlign = TA_BASELINE;
	currentBkMode = OPAQUE;
	currentBkColor = RGB(255,255,255);
	currentTextColor = RGB(0,0,0);
	currentEraseColor = RGB(128,0,0);
	drawBaseLine = TRUE;
	drawBoudingBox = FALSE;
}

BOOL SetDlgItemInt( HWND hDlg, int nIDDlgItem, int data )
{
	TCHAR buf[_MAX_PATH];
	wsprintf(buf,L"%d",data);
	return SetDlgItemText( hDlg, nIDDlgItem, buf);
}

BOOL SetDlgItemHex6( HWND hDlg, int nIDDlgItem, int data )
{
	TCHAR buf[_MAX_PATH];
	wsprintf(buf,L"%06x",data);
	return SetDlgItemText( hDlg, nIDDlgItem, buf);
}

void updateDraw( HWND hwndDlg )
{
	SetDlgItemInt( hwndDlg, IDC_TEXTALIGN, currentTextAlign );
	SetDlgItemInt( hwndDlg, IDC_BKMODE, currentBkMode );
	SetDlgItemHex6( hwndDlg, IDC_BKCOLOR, currentBkColor );
	SetDlgItemHex6( hwndDlg, IDC_TEXTCOLOR, currentTextColor );
	SetDlgItemHex6( hwndDlg, IDC_ERASECOLOR, currentEraseColor );

	if( drawBaseLine ) {
		SendDlgItemMessage( hwndDlg, IDC_BASELINE, BM_SETCHECK, BST_CHECKED, 0L );
	} else {
		SendDlgItemMessage( hwndDlg, IDC_BASELINE, BM_SETCHECK, BST_UNCHECKED, 0L );
	}
	if( drawBoudingBox ) {
		SendDlgItemMessage( hwndDlg, IDC_BOXDRAW, BM_SETCHECK, BST_CHECKED, 0L );
	} else {
		SendDlgItemMessage( hwndDlg, IDC_BOXDRAW, BM_SETCHECK, BST_UNCHECKED, 0L );
	}
}

void updateFontInfos()
{
	HDC hdc = getTargetDC();
	GetTextMetrics( hdc, &currentTextMetric );
	currentOutlineTextMetric.otmSize = sizeof(currentOutlineTextMetric);

	int cbData = GetOutlineTextMetrics (hdc, 0, NULL);
	if (cbData == 0) {
		lstrcpy( otmpFamilyName, L"ERROR" );
		lstrcpy( otmpFaceName, otmpFamilyName );
		lstrcpy( otmpStyleName, otmpFamilyName );
		lstrcpy( otmpFullName, otmpFamilyName );
	} else {
		void * temp = malloc( cbData );
		GetOutlineTextMetrics (hdc, cbData, (OUTLINETEXTMETRIC*)temp); 
		memcpy( &currentOutlineTextMetric, temp, sizeof(currentOutlineTextMetric) );

		lstrcpy( otmpFamilyName, (TCHAR*)(((BYTE*)temp) + ((int)currentOutlineTextMetric.otmpFamilyName)) );
		lstrcpy( otmpFaceName, (TCHAR*)(((BYTE*)temp) + ((int)currentOutlineTextMetric.otmpFaceName)) );
		lstrcpy( otmpStyleName, (TCHAR*)(((BYTE*)temp) + ((int)currentOutlineTextMetric.otmpStyleName)) );
		lstrcpy( otmpFullName, (TCHAR*)(((BYTE*)temp) + ((int)currentOutlineTextMetric.otmpFullName)) );

		free( temp );
	}

	GetTextFace( hdc, sizeof(currentFaceName), currentFaceName );
	releaseTargetDC(hdc);
	sizeChanged();
}

void cbAddString( HWND hwndDlg, int id, LPCTSTR str )
{
	SendDlgItemMessage( hwndDlg, id, CB_ADDSTRING, 0, (LPARAM)str );
}

int CALLBACK EnumFontFamExProc(
	ENUMLOGFONTEX *lpelfe,    // pointer to logical-font data
	NEWTEXTMETRICEX *lpntme,  // pointer to physical-font data
	int FontType,             // type of font
	LPARAM lParam             // application-defined data
)
{
	int r = SendMessage( (HWND)lParam, CB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)(LPCTSTR)lpelfe->elfLogFont.lfFaceName );
	if( r < 0 ) {
		SendMessage( (HWND)lParam, CB_ADDSTRING, 0, (LPARAM)(LPCTSTR)lpelfe->elfLogFont.lfFaceName );
	}
	return TRUE;
}

void initializeLogFont1( HWND hwndDlg )
{
	cbAddString( hwndDlg, CFD_HEIGHT, L"0=(default size)" );
	cbAddString( hwndDlg, CFD_WIDTH, L"0=(default size)" );
	cbAddString( hwndDlg, CFD_ESCAPEMENT, L"0=" );
	cbAddString( hwndDlg, CFD_ESCAPEMENT, L"900=" );
	cbAddString( hwndDlg, CFD_ESCAPEMENT, L"1800=" );
	cbAddString( hwndDlg, CFD_ESCAPEMENT, L"2700=" );
	cbAddString( hwndDlg, CFD_ORIENTATION, L"0=" );
	cbAddString( hwndDlg, CFD_ORIENTATION, L"900=" );
	cbAddString( hwndDlg, CFD_ORIENTATION, L"1800=" );
	cbAddString( hwndDlg, CFD_ORIENTATION, L"2700=" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"0=FW_DONTCARE" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"100=FW_THIN" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"200=FW_EXTRALIGHT/FW_ULTRALIGHT" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"300=FW_LIGHT" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"400=FW_NORMAL/FW_REGULAR" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"500=FW_MEDIUM" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"600=FW_SEMIBOLD/FW_DEMIBOLD" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"700=FW_BOLD" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"800=FW_EXTRABOLD/FW_ULTRABOLD" );
	cbAddString( hwndDlg, CFD_WEIGHT, L"900=FW_HEAVY/FW_BLACK" );
	cbAddString( hwndDlg, CFD_ITALIC, L"0=None" );
	cbAddString( hwndDlg, CFD_ITALIC, L"1=Italic" );
	cbAddString( hwndDlg, CFD_UNDERLINE, L"0=None" );
	cbAddString( hwndDlg, CFD_UNDERLINE, L"1=Underline" );
	cbAddString( hwndDlg, CFD_STRIKEOUT, L"0=None" );
	cbAddString( hwndDlg, CFD_STRIKEOUT, L"1=StrikeOut" );

	SetDlgItemInt( hwndDlg, CFD_HEIGHT, currentLogFont.lfHeight );
	SetDlgItemInt( hwndDlg, CFD_WIDTH, currentLogFont.lfWidth );
	SetDlgItemInt( hwndDlg, CFD_ESCAPEMENT, currentLogFont.lfEscapement );
	SetDlgItemInt( hwndDlg, CFD_ORIENTATION, currentLogFont.lfOrientation );
	SetDlgItemInt( hwndDlg, CFD_WEIGHT, currentLogFont.lfWeight );
	SetDlgItemInt( hwndDlg, CFD_ITALIC, currentLogFont.lfItalic );
	SetDlgItemInt( hwndDlg, CFD_UNDERLINE, currentLogFont.lfUnderline );
	SetDlgItemInt( hwndDlg, CFD_STRIKEOUT, currentLogFont.lfStrikeOut );
}

void initializeLogFont2( HWND hwndDlg )
{
	cbAddString( hwndDlg, CFD_CHARSET, L"0=ANSI_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"1=DEFAULT_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"2=SYMBOL_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"77=MAC_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"128=SHIFTJIS_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"129=HANGEUL_CHARSET/HANGUL_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"130=JOHAB_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"134=GB2312_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"136=CHINESEBIG5_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"161=GREEK_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"162=TURKISH_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"163=VIETNAMESE_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"177=HEBREW_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"178=ARABIC_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"186=BALTIC_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"204=RUSSIAN_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"222=THAI_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"238=EASTEUROPE_CHARSET" );
	cbAddString( hwndDlg, CFD_CHARSET, L"255=OEM_CHARSET" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"0=OUT_DEFAULT_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"1=OUT_STRING_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"2=OUT_CHARACTER_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"3=OUT_STROKE_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"4=OUT_TT_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"5=OUT_RASTER_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"6=OUT_TT_ONLY_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"7=OUT_OUTLINE_PRECIS" );
	cbAddString( hwndDlg, CFD_OUTPUTPRECISION, L"8=OUT_SCREEN_OUTLINE_PRECIS" );
	cbAddString( hwndDlg, CFD_CLIPPRECISION, L"0=CLIP_DEFAULT_PRECIS" );
	cbAddString( hwndDlg, CFD_CLIPPRECISION, L"1=CLIP_CHARACTER_PRECIS" );
	cbAddString( hwndDlg, CFD_CLIPPRECISION, L"2=CLIP_STROKE_PRECIS" );
	cbAddString( hwndDlg, CFD_QUALITY, L"0=DEFAULT_QUALITY" );
	cbAddString( hwndDlg, CFD_QUALITY, L"1=DRAFT_QUALITY" );
	cbAddString( hwndDlg, CFD_QUALITY, L"2=PROOF_QUALITY" );
	cbAddString( hwndDlg, CFD_QUALITY, L"3=NONANTIALIASED_QUALITY" );
	cbAddString( hwndDlg, CFD_QUALITY, L"4=ANTIALIASED_QUALITY" );
	cbAddString( hwndDlg, CFD_PITCH, L"0=DEFAULT_PITCH" );
	cbAddString( hwndDlg, CFD_PITCH, L"1=FIXED_PITCH" );
	cbAddString( hwndDlg, CFD_PITCH, L"2=VARIABLE_PITCH" );
	cbAddString( hwndDlg, CFD_PITCH, L"8=MONO_FONT" );
	cbAddString( hwndDlg, CFD_FAMILY, L"0=FF_DONTCARE" );
	cbAddString( hwndDlg, CFD_FAMILY, L"16=FF_ROMAN" );
	cbAddString( hwndDlg, CFD_FAMILY, L"32=FF_SWISS" );
	cbAddString( hwndDlg, CFD_FAMILY, L"48=FF_MODERN" );
	cbAddString( hwndDlg, CFD_FAMILY, L"64=FF_SCRIPT" );
	cbAddString( hwndDlg, CFD_FAMILY, L"80=FF_DECORATIVE" );

	LOGFONT searchTarget;
	memset( &searchTarget, 0, sizeof(LOGFONT) );
	searchTarget.lfCharSet = DEFAULT_CHARSET;
	HDC hdc = GetDC(hwndMain);
	EnumFontFamiliesEx( hdc, &searchTarget, (FONTENUMPROC)EnumFontFamExProc, (LPARAM)GetDlgItem(hwndDlg,CFD_FACENAME), 0 );
	ReleaseDC(hwndMain,hdc);

	SetDlgItemInt( hwndDlg, CFD_CHARSET, currentLogFont.lfCharSet );
	SetDlgItemInt( hwndDlg, CFD_OUTPUTPRECISION, currentLogFont.lfOutPrecision );
	SetDlgItemInt( hwndDlg, CFD_CLIPPRECISION, currentLogFont.lfClipPrecision );
	SetDlgItemInt( hwndDlg, CFD_QUALITY, currentLogFont.lfQuality );
	SetDlgItemInt( hwndDlg, CFD_PITCH, currentLogFont.lfPitchAndFamily & 0x03 );
	SetDlgItemInt( hwndDlg, CFD_FAMILY, currentLogFont.lfPitchAndFamily & 0xf0 );
	SetDlgItemText( hwndDlg, CFD_FACENAME, currentLogFont.lfFaceName );
}

void initializeDraw( HWND hwndDlg )
{
	cbAddString( hwndDlg, IDC_TEXTALIGN, L"0=TA_TOP" );
	cbAddString( hwndDlg, IDC_TEXTALIGN, L"8=TA_BOTTOM" );
	cbAddString( hwndDlg, IDC_TEXTALIGN, L"24=TA_BASELINE" );
	cbAddString( hwndDlg, IDC_BKMODE, L"1=TRANSPARENT" );
	cbAddString( hwndDlg, IDC_BKMODE, L"2=OPAQUE" );
	cbAddString( hwndDlg, IDC_BKCOLOR, L"000000=Black" );
	cbAddString( hwndDlg, IDC_BKCOLOR, L"FFFFFF=White" );
	cbAddString( hwndDlg, IDC_BKCOLOR, L"00FF00=Green" );
	cbAddString( hwndDlg, IDC_BKCOLOR, L"0000FF=Red" );
	cbAddString( hwndDlg, IDC_BKCOLOR, L"FF0000=Blue" );
	cbAddString( hwndDlg, IDC_BKCOLOR, L"C0C0C0=Gray" );

	cbAddString( hwndDlg, IDC_TEXTCOLOR, L"000000=Black" );
	cbAddString( hwndDlg, IDC_TEXTCOLOR, L"FFFFFF=White" );
	cbAddString( hwndDlg, IDC_TEXTCOLOR, L"00FF00=Green" );
	cbAddString( hwndDlg, IDC_TEXTCOLOR, L"0000FF=Red" );
	cbAddString( hwndDlg, IDC_TEXTCOLOR, L"FF0000=Blue" );
	cbAddString( hwndDlg, IDC_TEXTCOLOR, L"C0C0C0=Gray" );

	cbAddString( hwndDlg, IDC_ERASECOLOR, L"000000=Black" );
	cbAddString( hwndDlg, IDC_ERASECOLOR, L"FFFFFF=White" );
	cbAddString( hwndDlg, IDC_ERASECOLOR, L"00FF00=Green" );
	cbAddString( hwndDlg, IDC_ERASECOLOR, L"0000FF=Red" );
	cbAddString( hwndDlg, IDC_ERASECOLOR, L"FF0000=Blue" );
	cbAddString( hwndDlg, IDC_ERASECOLOR, L"C0C0C0=Gray" );

	updateDraw( hwndDlg );
}

BOOL CALLBACK fontSelDialogProc1( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg ) {
	case WM_INITDIALOG:
		initializeLogFont1( hwndDlg );
        {
            // [I] {^쐬ATCYw肵܂B  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
            shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
            shidi.hDlg = hwndDlg;
            SHInitDialog(&shidi);
        }
		return TRUE;
	case WM_COMMAND:
		{
			WORD wNotifyCode = HIWORD(wParam);
			WORD wID = LOWORD(wParam);
			HWND hwndCtl = (HWND) lParam;
			if( wID == IDOK ) {
				fillLogFont1(hwndDlg,currentLogFont);
				updateFontInfos();
				sizeChanged();
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
			if( wID == IDCANCEL ) {
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}

BOOL CALLBACK fontSelDialogProc2( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg ) {
	case WM_INITDIALOG:
		initializeLogFont2( hwndDlg );
        {
            // [I] {^쐬ATCYw肵܂B  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
            shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
            shidi.hDlg = hwndDlg;
            SHInitDialog(&shidi);
        }
		return TRUE;
	case WM_COMMAND:
		{
			WORD wNotifyCode = HIWORD(wParam);
			WORD wID = LOWORD(wParam);
			HWND hwndCtl = (HWND) lParam;
			if( wID == IDOK ) {
				fillLogFont2(hwndDlg,currentLogFont);
				updateFontInfos();
				sizeChanged();
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
			if( wID == IDCANCEL ) {
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}

BOOL CALLBACK drawSelDialogProc( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg ) {
	case WM_INITDIALOG:
		initializeDraw( hwndDlg );
        {
            // [I] {^쐬ATCYw肵܂B  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
            shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
            shidi.hDlg = hwndDlg;
            SHInitDialog(&shidi);
        }
		return TRUE;
	case WM_COMMAND:
		{
			WORD wNotifyCode = HIWORD(wParam);
			WORD wID = LOWORD(wParam);
			HWND hwndCtl = (HWND) lParam;
			if( wID == IDOK ) {
				fillDrawInfo(hwndDlg);
				InvalidateRect( hwndMain, NULL, TRUE );
				updateDraw( hwndDlg );
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
			if( wID == IDCANCEL ) {
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}

BOOL CALLBACK textDisplayDialogProc( HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	static BOOL nDeselectRequest;
	switch( uMsg ) {
	case WM_INITDIALOG:
        {
            // [I] {^쐬ATCYw肵܂B  
            SHINITDLGINFO shidi;
            shidi.dwMask = SHIDIM_FLAGS;
            shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
            shidi.hDlg = hwndDlg;
            SHInitDialog(&shidi);
        }
		SetDlgItemText( hwndDlg, IDC_EDIT_TEXTMETRIC, (LPCTSTR)lParam );
		// IԂŃeLXgo^Ă܂̂ŁAIB̃NGXgZbg
		nDeselectRequest = TRUE;
		return TRUE;
	case WM_COMMAND:
		{
			WORD wNotifyCode = HIWORD(wParam);
			WORD wID = LOWORD(wParam);
			HWND hwndCtl = (HWND) lParam;
			if( wID == IDOK || wID == IDCANCEL ) {
                EndDialog(hwndDlg, LOWORD(wParam));
				return TRUE;
			}
		}
		break;
	case WM_SIZE:
		{
			RECT client;
			GetClientRect( hwndDlg, &client );
			MoveWindow( GetDlgItem(hwndDlg, IDC_EDIT_TEXTMETRIC ), client.left,
				client.top, client.right-client.left, client.bottom-client.top, TRUE );

			// WM_INITDIALOG̒EM_SETSEL𑗂Ɩ̂
			// ŏWM_SIZEs鎞܂Œx (ŏ1WM_SIZE)
			if( nDeselectRequest )
			{
				SendDlgItemMessage( hwndDlg, IDC_EDIT_TEXTMETRIC, EM_SETSEL, -1, 0 );
				nDeselectRequest = FALSE;
			}
		}
		break;
	}
	return FALSE;
}

void CreateLogFontDialog1()
{
	DialogBox(g_hInst, (LPCTSTR)IDD_POCKETPC_SQUARE_LOGFONT1, hwndMain, (DLGPROC)fontSelDialogProc1);
}

void CreateLogFontDialog2()
{
	DialogBox(g_hInst, (LPCTSTR)IDD_POCKETPC_SQUARE_LOGFONT2, hwndMain, (DLGPROC)fontSelDialogProc2);
}

void CreateDrawDialog()
{
	DialogBox(g_hInst, (LPCTSTR)IDD_POCKETPC_SQUARE_DRAWSEL, hwndMain, (DLGPROC)drawSelDialogProc);
}

void CreateTextMetricDialog()
{
	TEXTMETRIC& tm = currentTextMetric;
	TCHAR buf[1500];
	TCHAR * p = buf;

	wsprintf(p,L"Height\t\t= %d\r\n",tm.tmHeight);
	p += wcslen(p);
	wsprintf(p,L"Ascent\t\t= %d\r\n",tm.tmAscent);
	p += wcslen(p);
	wsprintf(p,L"Descent\t\t= %d\r\n",tm.tmDescent);
	p += wcslen(p);
	wsprintf(p,L"InternalLeading\t= %d\r\n",tm.tmInternalLeading);
	p += wcslen(p);
	wsprintf(p,L"ExternalLeading\t= %d\r\n",tm.tmExternalLeading);
	p += wcslen(p);
	wsprintf(p,L"AveCharWidth\t= %d\r\n",tm.tmAveCharWidth);
	p += wcslen(p);
	wsprintf(p,L"MaxCharWidth\t= %d\r\n",tm.tmMaxCharWidth);
	p += wcslen(p);
	wsprintf(p,L"Weight\t\t= %d\r\n",tm.tmWeight);
	p += wcslen(p);
	wsprintf(p,L"Overhang\t\t= %d\r\n",tm.tmOverhang);
	p += wcslen(p);
	wsprintf(p,L"DigitizedAspectX\t= %d\r\n",tm.tmDigitizedAspectX);
	p += wcslen(p);
	wsprintf(p,L"DigitizedAspectY\t= %d\r\n",tm.tmDigitizedAspectY);
	p += wcslen(p);
	wsprintf(p,L"FirstChar\t\t= %d\r\n",tm.tmFirstChar);
	p += wcslen(p);
	wsprintf(p,L"LastChar\t\t= %d\r\n",tm.tmLastChar);
	p += wcslen(p);
	wsprintf(p,L"DefaultChar\t= %d\r\n",tm.tmDefaultChar);
	p += wcslen(p);
	wsprintf(p,L"BreakChar\t= %d\r\n",tm.tmBreakChar);
	p += wcslen(p);
	wsprintf(p,L"Italic\t\t= %d\r\n",tm.tmItalic);
	p += wcslen(p);
	wsprintf(p,L"Underlined\t= %d\r\n",tm.tmUnderlined);
	p += wcslen(p);
	wsprintf(p,L"StruckOut\t\t= %d\r\n",tm.tmStruckOut);
	p += wcslen(p);
	wsprintf(p,L"Pitch\t\t= %d\r\n",tm.tmPitchAndFamily & 0x3);
	p += wcslen(p);
	wsprintf(p,L"Family\t\t= %d\r\n",tm.tmPitchAndFamily & 0xf0);
	p += wcslen(p);
	wsprintf(p,L"CharSet\t\t= %d\r\n",tm.tmCharSet);

	lstrcat( buf, L"FaceName\t= " );
	lstrcat( buf, currentFaceName );

	DialogBoxParam(g_hInst, (LPCTSTR)IDD_POCKETPC_SQUARE_DISPLAY, hwndMain, (DLGPROC)textDisplayDialogProc, (LPARAM)buf );
}

void CreateOutlineTextMetricDialog()
{
	OUTLINETEXTMETRIC& otm = currentOutlineTextMetric;
	TCHAR buf[2000];
	TCHAR * p = buf;

	wsprintf(p,L"otmFiller\t\t\t= %d\r\n",otm.otmFiller);
	p += wcslen(p);
	wsprintf(p,L"otmfsSelection\t\t= %d\r\n",otm.otmfsSelection);
	p += wcslen(p);
	wsprintf(p,L"otmfsType\t\t= %d\r\n",otm.otmfsType);
	p += wcslen(p);
	wsprintf(p,L"otmsCharSlopeRise\t\t= %d\r\n",otm.otmsCharSlopeRise);
	p += wcslen(p);
	wsprintf(p,L"otmsCharSlopeRun\t\t= %d\r\n",otm.otmsCharSlopeRun);
	p += wcslen(p);
	wsprintf(p,L"otmItalicAngle\t\t= %d\r\n",otm.otmItalicAngle);
	p += wcslen(p);
	wsprintf(p,L"otmEMSquare\t\t= %d\r\n",otm.otmEMSquare);
	p += wcslen(p);
	wsprintf(p,L"otmAscent\t\t= %d\r\n",otm.otmAscent);
	p += wcslen(p);
	wsprintf(p,L"otmDescent\t\t= %d\r\n",otm.otmDescent);
	p += wcslen(p);
	wsprintf(p,L"otmLineGap\t\t= %d\r\n",otm.otmLineGap);
	p += wcslen(p);
	wsprintf(p,L"otmsCapEmHeight\t\t= %d\r\n",otm.otmsCapEmHeight);
	p += wcslen(p);
	wsprintf(p,L"otmsXHeight\t\t= %d\r\n",otm.otmsXHeight);
	p += wcslen(p);
	wsprintf(p,L"otmrcFontBox\t\t= %d,%d,%d,%d (Left,Right,Top,Bottom)\r\n",
		otm.otmrcFontBox.left,
		otm.otmrcFontBox.right,
		otm.otmrcFontBox.top,
		otm.otmrcFontBox.bottom );
	p += wcslen(p);
	wsprintf(p,L"otmMacAscent\t\t= %d\r\n",otm.otmMacAscent);
	p += wcslen(p);
	wsprintf(p,L"otmMacDescent\t\t= %d\r\n",otm.otmMacDescent);
	p += wcslen(p);
	wsprintf(p,L"otmMacLineGap\t\t= %d\r\n",otm.otmMacLineGap);
	p += wcslen(p);
	wsprintf(p,L"otmusMinimumPPEM\t\t= %d\r\n",otm.otmusMinimumPPEM);
	p += wcslen(p);
	wsprintf(p,L"otmptSubscriptSize\t\t= %d,%d (x,y)\r\n",otm.otmptSubscriptSize.x,otm.otmptSubscriptSize.y);
	p += wcslen(p);
	wsprintf(p,L"otmptSubscriptOffset\t= %d,%d (x,y)\r\n",otm.otmptSubscriptOffset.x,otm.otmptSubscriptOffset.y);
	p += wcslen(p);
	wsprintf(p,L"otmptSuperscriptSize\t= %d,%d (x,y)\r\n",otm.otmptSuperscriptSize.x,otm.otmptSuperscriptSize.y);
	p += wcslen(p);
	wsprintf(p,L"otmptSuperscriptOffset\t= %d,%d (x,y)\r\n",otm.otmptSuperscriptOffset.x,otm.otmptSuperscriptOffset.y);
	p += wcslen(p);
	wsprintf(p,L"otmsStrikeoutSize\t\t= %d\r\n",otm.otmsStrikeoutSize);
	p += wcslen(p);
	wsprintf(p,L"otmsStrikeoutPosition\t= %d\r\n",otm.otmsStrikeoutPosition);
	p += wcslen(p);
	wsprintf(p,L"otmsUnderscoreSize\t\t= %d\r\n",otm.otmsUnderscoreSize);
	p += wcslen(p);
	wsprintf(p,L"otmsUnderscorePosition\t= %d\r\n",otm.otmsUnderscorePosition);
	p += wcslen(p);

	wsprintf(p,L"otmpFamilyName\t\t= %s\r\n",otmpFamilyName);
	p += wcslen(p);
	wsprintf(p,L"otmpFaceName\t\t= %s\r\n",otmpFaceName);
	p += wcslen(p);
	wsprintf(p,L"otmpStyleName\t\t= %s\r\n",otmpStyleName);
	p += wcslen(p);
	wsprintf(p,L"otmpFullName\t\t= %s\r\n",otmpFullName);
	p += wcslen(p);

	wsprintf(p,L"otmPanoseNumber.bFamilyType\t= %d\r\n",otm.otmPanoseNumber.bFamilyType);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bSerifStyle\t\t= %d\r\n",otm.otmPanoseNumber.bSerifStyle);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bWeight\t\t= %d\r\n",otm.otmPanoseNumber.bWeight);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bProportion\t\t= %d\r\n",otm.otmPanoseNumber.bProportion);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bContrast\t\t= %d\r\n",otm.otmPanoseNumber.bContrast);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bLetterform\t\t= %d\r\n",otm.otmPanoseNumber.bLetterform);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bStrokeVariation\t= %d\r\n",otm.otmPanoseNumber.bStrokeVariation);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bArmStyle\t\t= %d\r\n",otm.otmPanoseNumber.bArmStyle);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bMidline\t\t= %d\r\n",otm.otmPanoseNumber.bMidline);
	p += wcslen(p);
	wsprintf(p,L"otmPanoseNumber.bXHeight\t\t= %d\r\n",otm.otmPanoseNumber.bXHeight);
	p += wcslen(p);

	DialogBoxParam(g_hInst, (LPCTSTR)IDD_POCKETPC_SQUARE_DISPLAY, hwndMain, (DLGPROC)textDisplayDialogProc, (LPARAM)buf );
}

void doScroll( HWND hWnd, int x, int y )
{
	int hmin, hmax;
	GetScrollRange( hWnd, SB_HORZ, &hmin, &hmax );
	int vmin, vmax;
	GetScrollRange( hWnd, SB_VERT, &vmin, &vmax );
	x = max(hmin,min(hmax,x));
	y = max(vmin,min(vmax,y));
	int xoff = GetScrollPos( hWnd, SB_HORZ )-x;
	int yoff = GetScrollPos( hWnd, SB_VERT )-y;
	SetScrollPos( hWnd, SB_HORZ, x, TRUE );
	SetScrollPos( hWnd, SB_VERT, y, TRUE );
	ScrollWindowEx( hWnd, xoff, yoff*heightOffset, NULL, NULL, NULL, NULL, SW_ERASE|SW_INVALIDATE );
}

void wmHScroll( HWND hWnd, int nScrollCode, int nPos )
{
	RECT rect;
	GetClientRect( hWnd, &rect );
	int vpos = GetScrollPos(hWnd,SB_VERT);
	int hpos = GetScrollPos(hWnd,SB_HORZ);
	switch( nScrollCode ) {
	case SB_LEFT:
		doScroll( hWnd, 0, vpos );
		break;
	case SB_RIGHT:
		doScroll( hWnd, INT_MAX, vpos );
		break;
	case SB_LINELEFT:
		doScroll( hWnd, hpos-widthOffset, vpos );
		break;
	case SB_LINERIGHT:
		doScroll( hWnd, hpos+widthOffset, vpos );
		break;
	case SB_PAGELEFT:
		doScroll( hWnd, hpos-(rect.right-rect.left), vpos );
		break;
	case SB_PAGERIGHT:
		doScroll( hWnd, hpos+(rect.right-rect.left), vpos );
		break;
	case SB_THUMBPOSITION:
		doScroll( hWnd, nPos, vpos );
		break;
	}
}

void wmVScroll( HWND hWnd, int nScrollCode, int nPos )
{
	RECT rect;
	GetClientRect( hWnd, &rect );
	int vpos = GetScrollPos(hWnd,SB_VERT);
	int hpos = GetScrollPos(hWnd,SB_HORZ);
	switch( nScrollCode ) {
	case SB_TOP:
		doScroll( hWnd, hpos, 0 );
		break;
	case SB_BOTTOM:
		doScroll( hWnd, hpos, INT_MAX );
		break;
	case SB_LINEUP:
		doScroll( hWnd, hpos, vpos-1 );
		break;
	case SB_LINEDOWN:
		doScroll( hWnd, hpos, vpos+1 );
		break;
	case SB_PAGEUP:
		doScroll( hWnd, hpos, vpos-(rect.bottom-rect.top)/heightOffset );
		break;
	case SB_PAGEDOWN:
		doScroll( hWnd, hpos, vpos+(rect.bottom-rect.top)/heightOffset );
		break;
	case SB_THUMBPOSITION:
		doScroll( hWnd, hpos, nPos );
		break;
	}
}

void SelectFontByDialog(HWND hwnd)
{
	LOGFONT lf;
	lf = currentLogFont;
	CHOOSEFONT cf;
	memset( &cf, 0, sizeof(cf) );
	cf.lStructSize = sizeof(CHOOSEFONT);
	cf.hwndOwner = hwnd;
	cf.lpLogFont = &lf;
	cf.Flags = CF_SCREENFONTS|CF_EFFECTS|CF_INITTOLOGFONTSTRUCT;
	BOOL b = ChooseFont( &cf );
	if( b == FALSE ) return;
	currentLogFont = lf;
#ifdef FORCE_CHARSET_DEFAULT
	currentLogFont.lfCharSet = DEFAULT_CHARSET;
#endif
	currentTextColor = cf.rgbColors;
	updateFontInfos();
	sizeChanged();
}

int WINAPI WinMain(HINSTANCE hInstance,
                   HINSTANCE hPrevInstance,
                   LPTSTR    lpCmdLine,
                   int       nCmdShow)
{
	MSG msg;

	// O[o XgO܂
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_AFONTEST, szWindowClass, MAX_LOADSTRING);

	// AvP[V̏s܂:
	if (!InitInstance(hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	HACCEL hAccelTable;
	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_AFONTESTWN));

	// C bZ[W [v:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}

//
//  ֐ : MyRegisterClass()
//
//  ړI : EBhE NXo^܂B
//
//  Rg:
//
ATOM MyRegisterClass(HINSTANCE hInstance, LPTSTR szWindowClass)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_AFONTESTWN));
	wc.hCursor       = 0;
	wc.hbrBackground = (HBRUSH) GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName	= NULL;
	wc.lpszClassName = szWindowClass;

	return RegisterClass(&wc);
}

//
//   ֐: InitInstance(HINSTANCE, int)
//
//   ړI : CX^X nhۑāAC EBhE쐬܂B
//
//   Rg:
//
//        ̊֐ŁAO[oϐŃCX^X nhۑA
//        C vO EBhE쐬ѕ\܂B
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
    TCHAR szTitle[MAX_LOADSTRING];		// ^Cg o[ eLXg
    TCHAR szWindowClass[MAX_LOADSTRING];	// C EBhE NX

    g_hInst = hInstance; // O[oϐɃCX^Xi[܂B

    // CAPEDIT  SIPPREF ̂悤ȃfoCXŗL̃Rg[ɂ́AAvP[V
    //  SHInitExtraControls xĂяoKv܂B
    SHInitExtraControls();

    LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING); 
    LoadString(hInstance, IDC_AFONTESTWN, szWindowClass, MAX_LOADSTRING);

    //ɎsĂꍇ́AEBhEɃtH[JX^AI܂B
    hwndMain = FindWindow(szWindowClass, szTitle);	
    if (hwndMain) 
    {
        // ŉʂ̎qEBhEɃtH[JXݒ肵܂B
        // L邷ׂẴEBhEOɔzuāAANeBuɂ邽߂ "| 0x00000001"
        // gp܂B
        SetForegroundWindow((HWND)((ULONG) hwndMain | 0x00000001));
        return 0;
    } 

    if (!MyRegisterClass(hInstance, szWindowClass))
    {
    	return FALSE;
    }

    hwndMain = CreateWindow(szWindowClass, szTitle, WS_VISIBLE,
        CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

    if (!hwndMain)
    {
        return FALSE;
    }

    // CW_USEDEFAULT gpăC EBhE쐬ꍇAmenubar ͍̍l
    // ܂Bmenubar ݂ꍇ́A쐬ŁAEBhẼTCY
    // w肵܂B
    if (g_hWndMenuBar)
    {
        RECT rc;
        RECT rcMenuBar;

        GetWindowRect(hwndMain, &rc);
        GetWindowRect(g_hWndMenuBar, &rcMenuBar);
        rc.bottom -= (rcMenuBar.bottom - rcMenuBar.top);
		
        MoveWindow(hwndMain, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, FALSE);
    }

	// set initial font informations
	initDrawParams();
	GetObject( GetStockObject(SYSTEM_FONT), sizeof(LOGFONT), (LPVOID)&currentLogFont );
#ifdef FORCE_CHARSET_DEFAULT
	currentLogFont.lfCharSet = DEFAULT_CHARSET;
#endif
	updateFontInfos();

    ShowWindow(hwndMain, nCmdShow);
    UpdateWindow(hwndMain);

    return TRUE;
}

//
//  ֐: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  ړI :  C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- ~bZ[W\Ė߂
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;
    HDC hdc;

    static SHACTIVATEINFO s_sai;
	
    switch (message) 
    {
        case WM_COMMAND:
			{
			int wmId    = LOWORD(wParam); 
			int wmEvent = HIWORD(wParam); 
			// j[Ỉ:
			switch( wmId ) {
				case IDM_HELP_ABOUT:
					DialogBox(g_hInst, (LPCTSTR)IDD_POCKETPC_SQUARE_ABOUT, hWnd, (DLGPROC)About);
					break;
				case ID_MENU_LOGFONT1:
					CreateLogFontDialog1();
					break;
				case ID_MENU_LOGFONT2:
					CreateLogFontDialog2();
					break;
				case IDM_DRAW:
					CreateDrawDialog();
					break;
				case IDM_TEXTMETRIC:
					CreateTextMetricDialog();
					break;
				case IDM_OUTLINETEXTMETRIC:
					CreateOutlineTextMetricDialog();
					break;
				case IDM_SELECTFONT:
					if( GetSystemMetrics(SM_CXSCREEN) >= GetSystemMetrics(SM_CYSCREEN) )
					{
						WCHAR buf[MAX_LOADSTRING];
					    LoadString(g_hInst, IDS_FONTSEL_WARN, buf, MAX_LOADSTRING); 
						MessageBox( hWnd, buf, szTitle, MB_OK );
					}
					else
					{
						SelectFontByDialog( hWnd );
					}
					break;
				case IDM_EXIT:
				case IDM_OK:
					DestroyWindow( hWnd );
					break;
				default:
					return DefWindowProc( hWnd, message, wParam, lParam );
				}
			}
            break;
        case WM_CREATE:
            SHMENUBARINFO mbi;

            memset(&mbi, 0, sizeof(SHMENUBARINFO));
            mbi.cbSize     = sizeof(SHMENUBARINFO);
            mbi.hwndParent = hWnd;
            mbi.nToolBarId = IDR_MENU;
            mbi.hInstRes   = g_hInst;

            if (!SHCreateMenuBar(&mbi)) 
            {
                g_hWndMenuBar = NULL;
            }
            else
            {
                g_hWndMenuBar = mbi.hwndMB;
            }

            // shell ANeBx[g̃XgN`܂B
            memset(&s_sai, 0, sizeof (s_sai));
            s_sai.cbSize = sizeof (s_sai);
            break;
        case WM_PAINT:
            hdc = BeginPaint(hWnd, &ps);
            
			wmPaint( hWnd, hdc );
            
            EndPaint(hWnd, &ps);
            break;
        case WM_DESTROY:
            CommandBar_Destroy(g_hWndMenuBar);
            PostQuitMessage(0);
            break;

        case WM_ACTIVATE:
            // bZ[W̃ANeBx[g shell ɒʒm܂B
            SHHandleWMActivate(hWnd, wParam, lParam, &s_sai, FALSE);
            break;
        case WM_SETTINGCHANGE:
            SHHandleWMSettingChange(hWnd, wParam, lParam, &s_sai);
            break;

		case WM_SIZE:
			sizeChanged();
			break;

		case WM_HSCROLL:
			{
				int nScrollCode = (int) LOWORD(wParam);
				int nPos = (short int) HIWORD(wParam);
				wmHScroll( hWnd, nScrollCode, nPos );
			}
			break;
		case WM_VSCROLL:
			{
				int nScrollCode = (int) LOWORD(wParam);
				int nPos = (short int) HIWORD(wParam);
				wmVScroll( hWnd, nScrollCode, nPos );
			}
			break;
		case WM_KEYDOWN:
			{
				int nVirtKey = (int) wParam;
				switch( nVirtKey ) {
				case VK_DOWN:
					wmVScroll( hWnd, SB_LINEDOWN, 0 );
					break;
				case VK_UP:
					wmVScroll( hWnd, SB_LINEUP, 0 );
					break;
				case VK_LEFT:
					wmHScroll( hWnd, SB_LINELEFT, 0 );
					break;
				case VK_RIGHT:
					wmHScroll( hWnd, SB_LINERIGHT, 0 );
					break;
				case VK_HOME:
					wmVScroll( hWnd, SB_TOP, 0 );
					break;
				case VK_END:
					wmVScroll( hWnd, SB_BOTTOM, 0 );
					break;
				case VK_PRIOR:
					wmVScroll( hWnd, SB_PAGEUP, 0 );
					break;
				case VK_NEXT:
					wmVScroll( hWnd, SB_PAGEDOWN, 0 );
					break;
				}
			}
			break;
		case WM_ERASEBKGND:
			{
				HDC hdc = (HDC) wParam;
				RECT rect;
				GetClientRect( hWnd, &rect );
				COLORREF oldColor = SetBkColor( hdc, currentEraseColor );
				ExtTextOut( hdc, 0, 0, ETO_OPAQUE, &rect, L"", 0, NULL ); 
				SetBkColor( hdc, oldColor );
				return TRUE;
			}

		default:
            return DefWindowProc(hWnd, message, wParam, lParam);
    }
    return 0;
}

// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
        case WM_INITDIALOG:
            {
                // [I] {^쐬ATCYw肵܂B  
                SHINITDLGINFO shidi;
                shidi.dwMask = SHIDIM_FLAGS;
                shidi.dwFlags = SHIDIF_DONEBUTTON | SHIDIF_SIPDOWN | SHIDIF_SIZEDLGFULLSCREEN | SHIDIF_EMPTYMENU;
                shidi.hDlg = hDlg;
                SHInitDialog(&shidi);
            }
            return (INT_PTR)TRUE;

        case WM_COMMAND:
            if (LOWORD(wParam) == IDOK)
            {
                EndDialog(hDlg, LOWORD(wParam));
                return TRUE;
            }
            break;

        case WM_CLOSE:
            EndDialog(hDlg, message);
            return TRUE;
    }
    return (INT_PTR)FALSE;
}
